/*
   Copyright (C) 2007 - 2017 by Benoit Timbert <benoit.timbert@free.fr>
   Part of the Battle for Wesnoth Project http://www.wesnoth.org/

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.

   See the COPYING file for more details.
*/

#pragma once

#include <string>
#include <cstdint>

class sha1_hash
{
public:

	/** Make a hash from a string */
	sha1_hash(const std::string& str);

	/** Display the hash */
	std::string display();
private:

	/** Process the next 512 bits block */
	void next(uint8_t block[64]);
	uint32_t H0, H1, H2, H3, H4;

};
